Subject: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

From: Philipp Stephani <[email-masked]>
Date: Thu, 2 Jul 2020 21:09:04 +0200

Am Do., 2. Juli 2020 um 12:28 Uhr schrieb Mattias Engdegård <[email-masked]>:
>
> 1 juli 2020 kl. 23.31 skrev Andrea Corallo <[email-masked]>:
>
> > Another reason why I'm interested is that I reuse these
> > definitions in the native compiler.
>
> In that case there are probably more functions you may want to consider for purity -- what about:
>
> < > <= >= = /=
> string< string= string-equal
> eq eql equal
> proper-list-p
> identity
> memq memql member
> assq assql assoc

I don't think most of those are pure, as they have to "look into" an
object. For example, the result of "equal" does not only depend on the
argument objects, but also the objects they refer to.